/*
Copyright (C) 2005 Observatoire de Paris-Meudon

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier conformment aux dispositions de la Licence Publique Gnrale GNU, telle que publie par la Free Software Foundation ; version 2 de la licence, ou encore ( votre choix) toute version ultrieure.

Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail, voir la Licence Publique Gnrale GNU .

Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en mme temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
*/

package orbites;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

/**
 * Zone d'affichage d'une image
 */
public class ImageCanvas extends Canvas implements MouseListener, MouseMotionListener {
    Dimension tailleImage;
    Orbites app; // ImageCanvas utilise initGraphics, majCroquis et topChrono
    Image img;
    Graphics gim;
    Point mousePos;
    
    public ImageCanvas(Orbites app, int w, int h) {
        this.app = app;
        setSize(w, h);
        tailleImage = new Dimension(w, h);
        img = null;
        addMouseListener(this);
        addMouseMotionListener(this);
        mousePos = null;
    }
    
    public Dimension getPreferredSize() {
        return tailleImage;
    }
    
    public Dimension getMinimumSize() {
        return tailleImage;
    }
    
    public void paint(Graphics g) {
        if (img == null) {
            img = createImage(tailleImage.width, tailleImage.height);
            gim = img.getGraphics();
            app.initGraphics(gim);
        }
        if (img != null) {
            app.majCroquis(gim);
            Dimension tailleZone = getSize();
            int x = (tailleZone.width - tailleImage.width)/2;
            int y = (tailleZone.height - tailleImage.height)/2;
            g.drawImage(img, x, y, null);
        }
        app.topChrono();
    }
    
    public void update(Graphics g) {
        paint(g);
    }
    
    public void mouseClicked(MouseEvent e) {
        Dimension tailleZone = getSize();
        int x = (tailleZone.width - tailleImage.width)/2;
        int y = (tailleZone.height - tailleImage.height)/2;
        app.selection(e.getX() - x, e.getY() - y);
    }
    
    public void mousePressed(MouseEvent e) {
    }
    
    public void mouseReleased(MouseEvent e) {
        mousePos = null;
    }
    
    public void mouseEntered(MouseEvent e) {
    }
    
    public void mouseExited(MouseEvent e) {
    }
    
    public void mouseDragged(MouseEvent e) {
        Point nouvPt = e.getPoint();
        if (mousePos != null)
            app.rotation(mousePos, nouvPt);
        mousePos = nouvPt;
    }
    
    public void mouseMoved(MouseEvent e) {
    }
}
